/*
 * Copyright 2010 Funambol, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* $Id$ */

#pragma once

#include "MD5Session.h"

namespace NS_DM_Client
{
	namespace NS_Communication
	{
		/// Class implements session based on the HMAC authentication scheme
		class HMACSession : public MD5Session
		{
		public:
			HMACSession(ConnectionInfo &, Funambol::TransportAgent &);
			virtual ~HMACSession();

			virtual const char * GetTypeName();
			virtual	bool IsResponseValid(const char *, uint resplength);
			virtual bool IsServerCredValid(Funambol::Cred *);

		protected:
			virtual void insertSessionInitiationCommands(int code);
			virtual void prepareTransport(const char *msg, uint msg_len);
		};
	}
}
